import { applyMiddleware, compose, createStore, Store } from 'redux';
import { routerMiddleware } from 'react-router-redux';
import createSagaMiddleware, { SagaMiddleware } from 'redux-saga';
import { History } from 'history';
import { createHashHistory } from 'history';

import reducer from './reducer';
import State from './state';

const history = createHashHistory();
const sagaMiddleware: SagaMiddleware<any> = createSagaMiddleware();
const middlewares = [sagaMiddleware, routerMiddleware(history)];

const store: Store<State> = createStore<State>(
    reducer,
    applyMiddleware(...middlewares),
);

export {
  history,
  sagaMiddleware,
  store,
};
