import * as React from 'react';
import { Container, Menu, Sidebar, Segment, Icon, Breadcrumb, Grid, Dropdown } from 'semantic-ui-react';
import { Header } from './Header';
import { Footer } from './Footer';
import { LeftMenu } from './LeftMenu';

// import { Routes } from './Routes';

import routes from '../../router';

import { Router } from 'react-router';
import * as History from 'history';

import { Provider } from 'react-redux';
import { ConnectedRouter } from 'react-router-redux';
import { store, sagaMiddleware, history } from '../../redux/store';

// const history = History.createHashHistory();

export class Layout extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
      sidebar_visible: true,
      notification_visible: false,
    };
  }

  public onSidebar = () => {
    this.setState({ notification_visible: !this.state.notification_visible, sidebar_visible: !this.state.sidebar_visible });
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Sidebar.Pushable as={Segment} vertical>
          <Sidebar as={Menu} animation='overlay' width='thin' visible={this.state.sidebar_visible} icon='labeled' vertical inverted>
            <LeftMenu />
          </Sidebar>
          <Sidebar.Pusher>
            <Segment vertical style={{ margin: '0 0 0 150px', padding: '0' }}>
              <Header />

              {/*<Router history={history} >
                {routes}
              </Router>*/}
              <Provider store={store}>
                <ConnectedRouter history={history}>
                  {routes}
                </ConnectedRouter>
              </Provider>

              <Footer />

            </Segment>
          </Sidebar.Pusher>
        </Sidebar.Pushable>
        {/* <Header onSidebar={this.onSidebar.bind(this)} />
          <Sidebar.Pushable as={Segment} vertical >
            <Sidebar
              as={Menu}
              animation='overlay'
              width='thin'
              direction='right'
              visible={this.state.notification_visible}
              icon='labeled'
              vertical
              inverted
            >
              <Menu.Item name='home'>
                Notification 1
            </Menu.Item>
              <Menu.Item name='gamepad'>
                Notification 2
            </Menu.Item>
            </Sidebar>

            <Sidebar.Pusher >
              <Container fluid textAlign='right' style={{ padding: '5px 20px 0px' }}>
                <Breadcrumb size='mini'>
                  <Breadcrumb.Section link>Home</Breadcrumb.Section>
                  <Breadcrumb.Divider icon='right angle' />
                  <Breadcrumb.Section link>Monitoring</Breadcrumb.Section>
                  <Breadcrumb.Divider icon='right angle' />
                  <Breadcrumb.Section active>Probe</Breadcrumb.Section>
                </Breadcrumb>
              </Container>

              <Segment vertical>
                <Container>
                  <Router history={history} >
                    <Routes />
                  </Router>
                </Container>

                <Footer />
              </Segment>
            </Sidebar.Pusher>
          </Sidebar.Pushable> */}


      </Container >
    );
  }
}



