import * as React from 'react';
import { Grid, Container, Breadcrumb, Header, Menu, Input, Segment } from 'semantic-ui-react';

export class TitleBar extends React.Component<any, any> {

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };
  }

  public render(): JSX.Element {
    let subMenus = [
      {
        'name': 'Menu1',
        'href': '#/test2',
      },
      {
        'name': 'Menu2',
        'href': '#/test3',
      },
      {
        'name': 'Menu3',
        'href': '#/test4',
      },
    ];
    return (
      <Menu basic fluid style={{ 'border-left': '0px', 'border-right': '0px', 'box-shadow': 'none', 'border-radius': '0' }}>
        <Menu.Item name='Page Title' style={{ width: '250px' }}>
          <Header as='h3'>Page Title
            <Header.Subheader>
              <Breadcrumb size='mini' left bottom>
                <Breadcrumb.Section link>Home</Breadcrumb.Section>
                <Breadcrumb.Divider />
                <Breadcrumb.Section link>Monitoring</Breadcrumb.Section>
                <Breadcrumb.Divider />
                <Breadcrumb.Section active>Probes</Breadcrumb.Section>
              </Breadcrumb>
            </Header.Subheader>
          </Header>
        </Menu.Item>
        {subMenus.map((menu: any, index: number) => (
          <Menu.Item key={index} name={menu.name} href={menu.href} />
        ))}
      </Menu>
    );
  }
}



