import AppContext from '../context';

abstract class Platform {

  public static getAppContainer(containerId: string): Promise<HTMLElement> {
    const appContainer = new Promise<HTMLElement>(resolve => {
      document.addEventListener('DOMContentLoaded', () => {
        resolve(document.getElementById(containerId));
      });
    });

    return appContainer;
  }

  public static * getAppContext(): IterableIterator<Promise<AppContext>> {
    const appContext = yield new Promise<AppContext>(resolve => {
      const context = AppContext.getContext();
      resolve(context);
    });

    return appContext;
  }

}

export default Platform;
