export const enum ErrorCode {
  E_PARSE = -32700,
  E_INVALID_REQ = -32600,
  E_NO_METHOD = -32601,
  E_BAD_PARAMS = -32602,
  E_INTERNAL = -32603,
  E_SERVER = -32000,

}

export class ProtocolError {
  private code: ErrorCode;
  private message: string;
  private data: any;

  public constructor(code: ErrorCode, message: string, data: any) {
    this.code = code;
    this.message = message;
    this.data = data;
  }

  /**
   * getID
   */
  public getCode(): ErrorCode {
    return this.code;
  }

  /**
   * getBody
   */
  public getMessage(): string {
    return this.message;
  }

  /**
   * getError
   */
  public getData(): any {
    return this.data;
  }

  public static newError(json: string): ProtocolError {
    return JSON.parse(json);
  }
}
