import { ProtocolSub } from '../ProtocolSub';

export class RPCRequest extends ProtocolSub {
  private readonly method: string;
  private readonly params: any[];

  public constructor(method: string, params: any[]) {
    super();
    this.method = method;
    this.params = params;
  }

  /**
   * getMethod
   */
  public getMethod(): string {
    return this.method;
  }

  /**
   * getParams
   */
  public getParams(): any[] {
    return this.params;
  }

  /**
   * toJSON
   */
  public toJSON(): string {
    return JSON.stringify(this);
  }
}
