import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import DomainMember from '../../api/model/DomainMember';
import DomainMemberService from '../../api/service/DomainMemberService';
import * as MemberRegistActions from '../action/member_regist';
import MemberRegistPayload from '../payload/MemberRegistPayload';

function* regist(action: Action<MemberRegistPayload>): SagaIterator {
  try {
    const dm = action.payload.domainMember;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    yield call(AppContext.getService<DomainMemberService>().regist, dm);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(MemberRegistActions.requestSuccess());
  } catch (e) {
    yield put(MemberRegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegist(): SagaIterator {
  yield takeLatest(MemberRegistActions.REQUEST, regist);
}
