import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Domain from '../../api/model/Domain';
import DomainService from '../../api/service/DomainService';
import * as RegistActions from '../action/regist';
import RegistPayload from '../payload/RegistPayload';

function* regist(action: Action<RegistPayload>): SagaIterator {
  try {
    const dm = action.payload.domain;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    yield call(AppContext.getService<DomainService>().regist, dm);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess());
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
