import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import EmailAuth from '@overflow/email/api/model/EmailAuth';

import EmailAuthService from '@overflow/email/api/service/EmailAuthService';
import * as ReadAction from '../action/read';
import ReadPayload from '../payload/ReadPayload';

function* read(action: Action<ReadPayload>): SagaIterator {
  try {
    const id = action.payload.id;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const emailAuth = yield call(AppContext.getService<EmailAuthService>().read, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadAction.requestSuccess(emailAuth));
  } catch (e) {
    yield put(ReadAction.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRead(): SagaIterator {
  yield takeLatest(ReadAction.REQUEST, read);
}
