import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import EmailAuth from '@overflow/email/api/model/EmailAuth';

import EmailAuthService from '@overflow/email/api/service/EmailAuthService';
import * as ReadByAuthKeyAction from '../action/read_by_auth_key';
import ReadByAuthKeyPayload from '../payload/ReadByAuthKeyPayload';

function* readByAuthKey(action: Action<ReadByAuthKeyPayload>): SagaIterator {
  try {
    const authKey = action.payload.authKey;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const emailAuth = yield call(AppContext.getService<EmailAuthService>().readByAuthKey, authKey);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadByAuthKeyAction.requestSuccess(emailAuth));
  } catch (e) {
    yield put(ReadByAuthKeyAction.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadByAuthKey(): SagaIterator {
  yield takeLatest(ReadByAuthKeyAction.REQUEST, readByAuthKey);
}
