import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import EmailAuth from '@overflow/email/api/model/EmailAuth';

import EmailAuthService from '@overflow/email/api/service/EmailAuthService';
import * as ReadByMemberAction from '../action/read_by_member';
import ReadByMemberPayload from '../payload/ReadByMemberPayload';

function* readByMember(action: Action<ReadByMemberPayload>): SagaIterator {
  try {
    const id = action.payload.memberId;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const emailAuths = yield call(AppContext.getService<EmailAuthService>().readByMember, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadByMemberAction.requestSuccess(emailAuths));
  } catch (e) {
    yield put(ReadByMemberAction.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadByMember(): SagaIterator {
  yield takeLatest(ReadByMemberAction.REQUEST, readByMember);
}
