import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import EmailAuth from '@overflow/email/api/model/EmailAuth';

import EmailAuthService from '@overflow/email/api/service/EmailAuthService';
import * as SendEmailAction from '../action/send_email_by_member';
import SendEmailPayload from '../payload/SendEmailByMemberPayload';

function* sendEmail(action: Action<SendEmailPayload>): SagaIterator {
  try {
    const {memberId, email} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const emailAuth = yield call(AppContext.getService<EmailAuthService>().sendEmailByMember, memberId, email);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(SendEmailAction.requestSuccess(emailAuth));
  } catch (e) {
    yield put(SendEmailAction.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchSendEmail(): SagaIterator {
  yield takeLatest(SendEmailAction.REQUEST, sendEmail);
}
