import Action from '@overflow/commons/redux/Action';
import InfraHost from '../..//api/model/InfraHost';

import HostReadPayload from '../payload/HostReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/host_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/host_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/host_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/host_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/host_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/host_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<HostReadPayload>;
export type requestSuccess = (infraHost: InfraHost) => Action<InfraHost>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<HostReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraHost: InfraHost): Action<InfraHost> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraHost,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
