import Action from '@overflow/commons/redux/Action';
import InfraMachine from '../..//api/model/InfraMachine';

import MachineReadPayload from '../payload/MachineReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/machine_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/machine_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/machine_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/machine_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/machine_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/machine_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<MachineReadPayload>;
export type requestSuccess = (infraMachine: InfraMachine) => Action<InfraMachine>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<MachineReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraMachine: InfraMachine): Action<InfraMachine> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraMachine,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
