import Action from '@overflow/commons/redux/Action';
import InfraOSApplication from '../..//api/model/InfraOSApplication';

import OSApplicationReadPayload from '../payload/OSApplicationReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/os_application_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/os_application_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/os_application_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/os_application_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/os_application_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/os_application_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<OSApplicationReadPayload>;
export type requestSuccess = (infraOSApplication: InfraOSApplication) => Action<InfraOSApplication>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<OSApplicationReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraOSApplication: InfraOSApplication): Action<InfraOSApplication> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraOSApplication,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
