import Action from '@overflow/commons/redux/Action';
import InfraOSDaemon from '../..//api/model/InfraOSDaemon';

import OSDaemonReadPayload from '../payload/OSDaemonReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/os_daemon_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/os_daemon_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/os_daemon_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/os_daemon_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/os_daemon_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/os_daemon_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<OSDaemonReadPayload>;
export type requestSuccess = (infraOSDaemon: InfraOSDaemon) => Action<InfraOSDaemon>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<OSDaemonReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraOSDaemon: InfraOSDaemon): Action<InfraOSDaemon> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraOSDaemon,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
