import Action from '@overflow/commons/redux/Action';
import InfraOSPort from '../..//api/model/InfraOSPort';

import OSPortReadPayload from '../payload/OSPortReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/os_port_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/os_port_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/os_port_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/os_port_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/os_port_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/os_port_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<OSPortReadPayload>;
export type requestSuccess = (infraOSPort: InfraOSPort) => Action<InfraOSPort>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<OSPortReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraOSPort: InfraOSPort): Action<InfraOSPort> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraOSPort,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
