import Action from '@overflow/commons/redux/Action';
import Infra from '../..//api/model/Infra';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<ReadPayload>;
export type requestSuccess = (infra: Infra) => Action<Infra>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<ReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infra: Infra): Action<Infra> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infra,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
