import Action from '@overflow/commons/redux/Action';
import InfraService from '../..//api/model/InfraService';

import ServiceReadPayload from '../payload/ServiceReadPayload';

// Action Type
export type REQUEST = '@overflow/infra/service_read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/infra/service_read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/infra/service_read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/infra/service_read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/infra/service_read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/infra/service_read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<ServiceReadPayload>;
export type requestSuccess = (infraService: InfraService) => Action<InfraService>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<ServiceReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (infraService: InfraService): Action<InfraService> => {
  return {
      type: REQUEST_SUCCESS,
      payload: infraService,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
