import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import InfraHost from '../../api/model/InfraHost';
import InfraHostService from '../../api/service/InfraHostService';
import * as RegistActions from '../action/host_regist';
import HostRegistPayload from '../payload/HostRegistPayload';

function* regist(action: Action<HostRegistPayload>): SagaIterator {
  try {
    const {infraHost} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraHostService>().regist, infraHost);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchHostRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
