import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import InfraMachine from '../../api/model/InfraMachine';
import InfraMachineService from '../../api/service/InfraMachineService';
import * as RegistActions from '../action/machine_regist';
import MachineRegistPayload from '../payload/MachineRegistPayload';

function* regist(action: Action<MachineRegistPayload>): SagaIterator {
  try {
    const {infraMachine} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraMachineService>().regist, infraMachine);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchMachineRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
