import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import InfraOSApplication from '../../api/model/InfraOSApplication';
import InfraOSApplicationService from '../../api/service/InfraOSApplicationService';
import * as RegistActions from '../action/os_application_regist';
import OSApplicationRegistPayload from '../payload/OSApplicationRegistPayload';

function* regist(action: Action<OSApplicationRegistPayload>): SagaIterator {
  try {
    const {infraOSApplication} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraOSApplicationService>().regist, infraOSApplication);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSApplicationRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
