import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import InfraOSPort from '../../api/model/InfraOSPort';
import InfraOSPortService from '../../api/service/InfraOSPortService';
import * as RegistActions from '../action/os_port_regist';
import OSPortRegistPayload from '../payload/OSPortRegistPayload';

function* regist(action: Action<OSPortRegistPayload>): SagaIterator {
  try {
    const {infraOSPort} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraOSPortService>().regist, infraOSPort);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSPortRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
