import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import InfraOS from '../../api/model/InfraOS';
import InfraOSService from '../../api/service/InfraOSService';
import * as ReadActions from '../action/os_read';
import OSReadPayload from '../payload/OSReadPayload';

function* read(action: Action<OSReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraOSService>().read, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchOSRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
