import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Infra from '../../api/model/Infra';
import InfraService from '../../api/service/InfraService';
import * as RegistActions from '../action/os_regist';
import RegistPayload from '../payload/RegistPayload';

function* regist(action: Action<RegistPayload>): SagaIterator {
  try {
    const {infra} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retApikey = yield call(AppContext.getService<InfraService>().regist, infra);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
