import *as React from 'react';
import {
  Input,
  InputOnChangeData,
  Select,
  Button,
  Header,
  Modal,
  Grid,
  Form,
  Container,
  ButtonProps,
} from 'semantic-ui-react';

const options = [
  { key: 'southkorea', value: '82', text: 'South Korea(82)' },
  { key: 'unitedstates', value: '1', text: 'United States(1)' },
];
export interface StateProps {
}

export interface DispatchProps {
  onSignIn?(signinId: string, signinPw: string ): void;
  onSignUp?(): void;
  onResetPassword?():void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  forgotPopup: boolean;
  sendComPopup: boolean;
  email: string;
  pass: string;
}

export class SignIn extends React.Component<Props, State> {
  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      forgotPopup: false,
      sendComPopup: false,
      email: '',
      pass: '',
    };


  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Grid>
          <Grid.Row>
            <Grid.Column mobile={16} tablet={5} computer={5}>
            </Grid.Column>
            <Grid.Column mobile={16} tablet={6} computer={6}>
              <Form>
                <Form.Input fluid placeholder='Email' onChange={
                (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                  this.setState({ email: data.value });
                }} />
                <Form.Input fluid placeholder='Password' type='password' onChange={
                (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                  this.setState({ pass: data.value });
                }} />
                <div style={{textAlign:'right'}}>
                  <a style={{fontSize:10}} onClick={this.forgotPopupOpen}>Forgot Password</a>
                </div>
                <Form.Group>
                <Button fluid primary style={{margin:'7'}} onClick={ this.signInClick.bind(this) }>    Sign In  </Button>
                <Button fluid style={{margin:'7'}} href='/#/test2'>    Sign Up  </Button>
                </Form.Group>
              </Form>
            </Grid.Column>
            <Grid.Column mobile={16} tablet={4} computer={5}>
            </Grid.Column>
          </Grid.Row>
        </Grid>

        <Modal size='small' open={this.state.forgotPopup} onClose={this.PopupClose}>
          <Modal.Header>Change your password</Modal.Header>
          <Modal.Content >
            Enter email address
            <Grid>
              <Grid.Column mobile={16} tablet={3} computer={4}>
              </Grid.Column>
              <Grid.Column mobile={16} tablet={10} computer={8}>
               <Input fluid placeholder='Email' />
              </Grid.Column>
              <Grid.Column mobile={16} tablet={3} computer={4}>
              </Grid.Column>
            </Grid>
          </Modal.Content>
          <Modal.Actions>
            <Button primary onClick={this.sendComOpen}>              Submit      </Button>
            <Button onClick={this.PopupClose}>              Cancel      </Button>
          </Modal.Actions>
        </Modal>

        <Modal size='small' open={this.state.sendComPopup} onClose={this.PopupClose}>
          <Modal.Header>Send Complete</Modal.Header>
          <Modal.Content>
            <Modal.Description>
              <Header>비밀번호 변경이 신청 되었습니다.</Header>
              <p>수신하신 메일의 주소에서 비밀번호 변경을 완료 하시기 바랍니다.</p>
            </Modal.Description>
          </Modal.Content>
          <Modal.Actions>
            <Button primary onClick={this.PopupClose}>              Ok      </Button>
          </Modal.Actions>
        </Modal>
      </Container>
    );
  }

  private forgotPopupOpen = () => this.setState({ forgotPopup: true });
  private PopupClose = () => this.setState({ forgotPopup: false, sendComPopup: false });
  private sendComOpen = () => {
    this.setState({
      forgotPopup: false,
      sendComPopup: true,

    });
  }

  private signInClick(event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void {
    this.props.onSignIn(this.state.email, this.state.pass);
  }
}
