import *as React from 'react';
import Member from '../../api/model/Member';

import {
  InputOnChangeData,
  Button,
  Grid,
  Form,
  Container, ButtonProps,
} from 'semantic-ui-react';

export interface StateProps {
}

export interface DispatchProps {
  onSignUp?(member: Member): void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  email: string;
  name: string;
  pass: string;
  passCon: string;
  company: string;
  phone: string;
  country: string;
}

const options = [
  { key: 'southkorea', value: '82', text: 'South Korea(82)' },
  { key: 'unitedstates', value: '1', text: 'United States(1)' },
];


export class SignUp extends React.Component<Props, State> {
  constructor(props?: Props, context?: State) {
    super(props, context);

    this.state = {
      email: null,
      name: null,
      pass: null,
      passCon: null,
      company: null,
      phone: null,
      country: null,
    };

  }

  public onChange (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData):void {
    console.log(event);
    console.log(data);
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Grid>
          <Grid.Row>
            <Grid.Column mobile={16} tablet={5} computer={5}>
            </Grid.Column>
            <Grid.Column mobile={16} tablet={6} computer={6}>
              <Form>
                <Form.Input fluid value={this.state.email} placeholder='Email' onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ email: data.value });
                  }} />
                <Form.Input fluid placeholder='Name' onChange= {
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ name: data.value });
                  }
                }/>
                <Form.Input fluid placeholder='Password' type='password' onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ pass: data.value });
                  }
                } />
                <Form.Input fluid placeholder='Password Confirm' type='password' onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ passCon: data.value });
                  }
                } />
                <Form.Input fluid placeholder='Company' onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ company: data.value });
                  }
                }/>
                <Form.Select fluid value={this.state.country} placeholder='Select your country' options={options} onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ country: data.value });
                  }
                } />
                <Form.Input fluid placeholder='phone' onChange={
                  (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
                    this.setState({ phone: data.value });
                  }
                } />
                <Form.Group>
                  <Button primary fluid style={{margin:'7'}} onClick={this.signUpClick}>   Sign Up  </Button>
                  <Button fluid style={{margin:'7'}}>    Cancel  </Button>
                </Form.Group>
              </Form>
            </Grid.Column>
            <Grid.Column mobile={16} tablet={4} computer={5}>
            </Grid.Column>
          </Grid.Row>
        </Grid>
      </Container>

    );
  }

  private signUpClick(event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void {

    // this.props.onSignUp(member);
  }

}

