import Action from '@overflow/commons/redux/Action';
import Member from '@overflow/member/api/model/Member';

import PWChangePayload from '../payload/PWChangePayload';

// Action Type
export type REQUEST = '@overflow/member/pw_change/REQUEST';
export type REQUEST_SUCCESS = '@overflow/member/pw_change/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/member/pw_change/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/member/pw_change/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/member/pw_change/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/member/pw_change/REQUEST_FAILURE';

// Action Creater
export type request = (pass: string) => Action<PWChangePayload>;
export type requestSuccess = (member: Member) => Action<Member>;
export type requestFailure = (error: Error) => Action;

export const request: request = (pass: string): Action<PWChangePayload> => {
  return {
    type: REQUEST,
    payload: {
      pass: pass,
    },
  };
};

export const requestSuccess: requestSuccess = (member: Member): Action<Member> => {
  return {
    type: REQUEST_SUCCESS,
    payload: member,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};