import Action from '@overflow/commons/redux/Action';
import Member from '@overflow/member/api/model/Member';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/member/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/member/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/member/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/member/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/member/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/member/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<ReadPayload>;
export type requestSuccess = (member: Member) => Action<Member>;
export type requestFailure = (error: Error) => Action;

export const request: request = (id: number): Action<ReadPayload> => {
  return {
    type: REQUEST,
    payload: {
      id: id,
    },
  };
};

export const requestSuccess: requestSuccess = (member: Member): Action<Member> => {
  return {
    type: REQUEST_SUCCESS,
    payload: member,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
