import Action from '@overflow/commons/redux/Action';

// Action Type
export type REQUEST = '@overflow/member/signout/REQUEST';
export type REQUEST_SUCCESS = '@overflow/member/signout/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/member/signout/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/member/signout/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/member/signout/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/member/signout/REQUEST_FAILURE';

// Action Creater
export type request = () => Action;
export type requestSuccess = () => Action;
export type requestFailure = (error: Error) => Action;

export const request: request = (): Action => {
  return {
      type: REQUEST,
    };
};

export const requestSuccess: requestSuccess = (): Action => {
  return {
      type: REQUEST_SUCCESS,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
