import Action from '@overflow/commons/redux/Action';
import Member from '@overflow/member/api/model/Member';

import SigninPayload from '../payload/SignInPayload';

// Action Type
export type REQUEST = '@overflow/member/signup/REQUEST';
export type REQUEST_SUCCESS = '@overflow/member/signup/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/member/signup/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/member/signup/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/member/signup/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/member/signup/REQUEST_FAILURE';

// Action Creater
export type request = (member: Member) => Action<Member>;
export type requestSuccess = (member: Member) => Action<Member>;
export type requestFailure = (error: Error) => Action;

export const request: request = (member: Member): Action<Member> => {
  return {
      type: REQUEST,
      payload: member,
    };
};

export const requestSuccess: requestSuccess = (member: Member): Action<Member> => {
  return {
      type: REQUEST_SUCCESS,
      payload: member,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
