import Action from '@overflow/commons/redux/Action';
import Member from '@overflow/member/api/model/Member';

import * as SignoutActionTypes from '../action/signOut';
import SigninState, { defaultState as signinDefaultState } from '../state/SignIn';

export type reducer = (state: SigninState, action: Action) => SigninState;

export const reducer: reducer = (state: SigninState = signinDefaultState, action: Action): SigninState => {
  switch (action.type) {
    case SignoutActionTypes.REQUEST_SUCCESS:
    {
      const aaa: SigninState = {
        ...state,
        isAuthenticated: true,
      };

      return aaa;
    }
    case SignoutActionTypes.REQUEST_FAILURE:
    {
      return state;
    }
    default:
      return state;
  }
};
