import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Member from '../../api/model/Member';
import MemberService from '../../api/service/MemberService';
import * as ReadActions from '../action/read';
import ReadPayload from '../payload/ReadPayload';

function* read(action: Action<ReadPayload>): SagaIterator {
  try {
    const id = action.payload.id;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const member = yield call(AppContext.getService<MemberService>().read, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(member));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
