import Action from '@overflow/commons/redux/Action';
import Member from '@overflow/member/api/model/Member';

import SignupActionTypes from '../action/signUp';
import SignupState, { defaultState as signupDefaultState } from '../state/SignUp';

export type reducer = (state: SignupState, action: Action<Member | Error>) => SignupState;

export const reducer: reducer = (state: SignupState = signupDefaultState, action: Action<Member | Error>): SignupState => {
  switch (action.type) {
    case SignupActionTypes.REQUEST_SUCCESS:
    {
      let member = (<Action<Member>>action).payload;

      const aaa: SignupState = {
        ...state,
        isRegistered: true,
      };

      return aaa;
    }
    case SignupActionTypes.REQUEST_FAILURE:
    {
      return state;
    }
    default:
      return state;
  }
};
