import Action from '@overflow/commons/redux/Action';
import NoAuthProbe from '../..//api/model/NoAuthProbe';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/noAuthProbe/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/noAuthProbe/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/noAuthProbe/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/noAuthProbe/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/noAuthProbe/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/noAuthProbe/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: number) => Action<ReadPayload>;
export type requestSuccess = (noAuthProbe: NoAuthProbe) => Action<NoAuthProbe>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: number): Action<ReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id:id,
      },
    };
};

export const requestSuccess: requestSuccess = (noAuthProbe: NoAuthProbe): Action<NoAuthProbe> => {
  return {
      type: REQUEST_SUCCESS,
      payload: noAuthProbe,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
