import Action from '@overflow/commons/redux/Action';
import NoAuthProbe from '../../api/model/NoAuthProbe';
import Domain from '@overflow/domain/api/model/Domain';

import ReadAllByDomainPayload from '../payload/ReadAllByDomainPayload';

// Action Type
export type REQUEST = '@overflow/noAuthProbe/read_all_by_domain/REQUEST';
export type REQUEST_SUCCESS = '@overflow/noAuthProbe/read_all_by_domain/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/noAuthProbe/read_all_by_domain/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/noAuthProbe/read_all_by_domain/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/noAuthProbe/read_all_by_domain/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/noAuthProbe/read_all_by_domain/REQUEST_FAILURE';

// Action Creater
export type request = (domain: Domain) => Action<ReadAllByDomainPayload>;
export type requestSuccess = (noAuthProbeList: NoAuthProbe[]) => Action<NoAuthProbe[]>;
export type requestFailure = (error: Error) => Action;



export const request: request = (domain: Domain): Action<ReadAllByDomainPayload> => {
  return {
      type: REQUEST,
      payload: {
        domain:domain,
      },
    };
};

export const requestSuccess: requestSuccess = (noAuthProbeList: NoAuthProbe[]): Action<NoAuthProbe[]> => {
  return {
      type: REQUEST_SUCCESS,
      payload: noAuthProbeList,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
