import Action from '@overflow/commons/redux/Action';
import NoAuthProbe from '../..//api/model/NoAuthProbe';

import RegistPayload from '../payload/RegistPayload';

// Action Type
export type REQUEST = '@overflow/noAuthProbe/regist/REQUEST';
export type REQUEST_SUCCESS = '@overflow/noAuthProbe/regist/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/noAuthProbe/regist/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/noAuthProbe/regist/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/noAuthProbe/regist/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/noAuthProbe/regist/REQUEST_FAILURE';

// Action Creater
export type request = (noAuthProbe: NoAuthProbe) => Action<RegistPayload>;
export type requestSuccess = (noAuthProbe: NoAuthProbe) => Action<NoAuthProbe>;
export type requestFailure = (error: Error) => Action;



export const request: request = (noAuthProbe: NoAuthProbe): Action<RegistPayload> => {
  return {
      type: REQUEST,
      payload: {
        noAuthProbe:noAuthProbe,
      },
    };
};

export const requestSuccess: requestSuccess = (noAuthProbe: NoAuthProbe): Action<NoAuthProbe> => {
  return {
      type: REQUEST_SUCCESS,
      payload: noAuthProbe,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
