import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import NoAuthProbe from '../../api/model/NoAuthProbe';
import NoAuthProbeService from '../../api/service/NoAuthProbeService';
import * as ReadActions from '../action/read_all_by_domain';
import ReadAllByDomainPayload from '../payload/ReadAllByDomainPayload';

function* readAllByDomain(action: Action<ReadAllByDomainPayload>): SagaIterator {
  try {
    const {domain} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const noauthProbeList = yield call(AppContext.getService<NoAuthProbeService>().readAllByDomain, domain);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(noauthProbeList));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadAllByDomain(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, readAllByDomain);
}
