import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Probe from '../../api/model/Probe';
import ProbeService from '../../api/service/ProbeService';
import * as ReadByProbeKeyActions from '../action/read_by_probekey';
import ReadByProbeKeyPayload from '../payload/ReadByProbeKeyPayload';

function* readByProbeKey(action: Action<ReadByProbeKeyPayload>): SagaIterator {
  try {
    const {probeKey} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const ret = yield call(AppContext.getService<ProbeService>().readByProbeKey, probeKey);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadByProbeKeyActions.requestSuccess(ret));
  } catch (e) {
    yield put(ReadByProbeKeyActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadByProbeKey(): SagaIterator {
  yield takeLatest(ReadByProbeKeyActions.REQUEST, readByProbeKey);
}
