import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import ProbeTaskService from '../../api/service/ProbeTaskService';
import * as TaskReadAllByProbeActions from '../action/task_read_all_by_probe';
import TaskReadAllByProbePayload from '../payload/TaskReadAllByProbePayload';

function* readAllTaskByProbe(action: Action<TaskReadAllByProbePayload>): SagaIterator {
  try {
    const {probe} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const ret = yield call(AppContext.getService<ProbeTaskService>().readAllByProbe, probe);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(TaskReadAllByProbeActions.requestSuccess(ret));
  } catch (e) {
    yield put(TaskReadAllByProbeActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadAllTaskByProbe(): SagaIterator {
  yield takeLatest(TaskReadAllByProbeActions.REQUEST, readAllTaskByProbe);
}
