import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import ProbeTask from '../../api/model/ProbeTask';
import ProbeTaskService from '../../api/service/ProbeTaskService';
import * as TaskRegistActions from '../action/task_regist';
import TaskRegistPayload from '../payload/TaskRegistPayload';

function* registTask(action: Action<TaskRegistPayload>): SagaIterator {
  try {
    const {probeTask} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const ret = yield call(AppContext.getService<ProbeTaskService>().regist, probeTask);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(TaskRegistActions.requestSuccess(ret));
  } catch (e) {
    yield put(TaskRegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegistTask(): SagaIterator {
  yield takeLatest(TaskRegistActions.REQUEST, registTask);
}
