import { connect, Dispatch } from 'react-redux';
import {
  SensorDetail,
  SensorDetailStateProps,
  SensorDetailDispatchProps,
} from './components/SensorDetail';
import State from '../redux/state/Read';

import * as ReadActions from '../redux/action/read';
import Target from '@overflow/target/api/model/Target';
import Sensor from '@overflow/sensor/api/model/Sensor';

export function mapStateToProps(state: any): SensorDetailStateProps {
  return {
    sensor:state.sensor,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorDetailDispatchProps {
  return {
    onRead: (id: number) => {
      dispatch(ReadActions.request(id));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorDetail);
