import { connect, Dispatch } from 'react-redux';
import {
  SensorList,
  StateProps as SensorListStateProps,
  DispatchProps as SensorListDispatchProps,
} from './components/SensorList';
import State from '../redux/state/ReadAllByTarget';

import * as ReadAllByTargetActions from '../redux/action/read_all_by_target';
import Target from '@overflow/target/api/model/Target';
import Sensor from '@overflow/sensor/api/model/Sensor';

export function mapStateToProps(state: any): SensorListStateProps {
  return {
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorListDispatchProps {
  return {
    onReadAllByTarget: (target: Target) => {
      dispatch(ReadAllByTargetActions.request(target));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorList);
