import Action from '@overflow/commons/redux/Action';
import SensorItem from '../../api/model/SensorItem';
import ItemReadPayload from '../payload/ItemReadPayload';

// Action Type
export type REQUEST = '@overflow/sensor_item/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/sensor_item/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/sensor_item/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/sensor_item/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/sensor_item/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/sensor_item/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: string) => Action<ItemReadPayload>;
export type requestSuccess = (sensorItem: SensorItem) => Action<SensorItem>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: string): Action<ItemReadPayload> => {
  return {
    type: REQUEST,
    payload: {
      id: id,
    },
  };
};

export const requestSuccess: requestSuccess = (sensorItem: SensorItem): Action<SensorItem> => {
  return {
    type: REQUEST_SUCCESS,
    payload: sensorItem,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
