import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import SensorItem from '../../api/model/SensorItem';
import SensorItemService from '../../api/service/SensorItemService';
import * as ItemRegistActions from '../action/item_regist';
import ItemRegistPayload from '../payload/ItemRegistPayload';

function* registItem(action: Action<ItemRegistPayload>): SagaIterator {
  try {
    const {sensorItem} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const ret = yield call(AppContext.getService<SensorItemService>().regist, sensorItem);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ItemRegistActions.requestSuccess(ret));
  } catch (e) {
    yield put(ItemRegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegistItem(): SagaIterator {
  yield takeLatest(ItemRegistActions.REQUEST, registItem);
}
