import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import SensorItem from '../../api/model/SensorItem';
import SensorItemService from '../../api/service/SensorItemService';
import * as ItemRemoveActions from '../action/item_remove';
import ItemRemovePayload from '../payload/ItemRemovePayload';

function* removeItem(action: Action<ItemRemovePayload>): SagaIterator {
  try {
    const {sensorItem} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    yield call(AppContext.getService<SensorItemService>().remove, sensorItem);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ItemRemoveActions.requestSuccess());
  } catch (e) {
    yield put(ItemRemoveActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRemoveItem(): SagaIterator {
  yield takeLatest(ItemRemoveActions.REQUEST, removeItem);
}
