import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Sensor from '../../api/model/Sensor';
import SensorService from '../../api/service/SensorService';
import * as ReadAllByTargetActions from '../action/read_all_by_target';
import ReadAllByTargetPayload from '../payload/ReadAllByTargetPayload';

function* readAllByTarget(action: Action<ReadAllByTargetPayload>): SagaIterator {
  try {
    const {target} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const ret = yield call(AppContext.getService<SensorService>().readAllByTarget, target);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadAllByTargetActions.requestSuccess(ret));
  } catch (e) {
    yield put(ReadAllByTargetActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadAllByTarget(): SagaIterator {
  yield takeLatest(ReadAllByTargetActions.REQUEST, readAllByTarget);
}
