import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Sensor from '../../api/model/Sensor';
import SensorService from '../../api/service/SensorService';
import * as RemoveActions from '../action/remove';
import RemovePayload from '../payload/RemovePayload';

function* remove(action: Action<RemovePayload>): SagaIterator {
  try {
    const {sensor} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retSensor = yield call(AppContext.getService<SensorService>().remove, sensor);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RemoveActions.requestSuccess(retSensor));
  } catch (e) {
    yield put(RemoveActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRemove(): SagaIterator {
  yield takeLatest(RemoveActions.REQUEST, remove);
}
