import Action from '@overflow/commons/redux/Action';
import Target from '../../api/model/Target';

import ReadPayload from '../payload/ReadPayload';

// Action Type
export type REQUEST = '@overflow/target/read/REQUEST';
export type REQUEST_SUCCESS = '@overflow/target/read/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/target/read/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/target/read/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/target/read/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/target/read/REQUEST_FAILURE';

// Action Creater
export type request = (id: string) => Action<ReadPayload>;
export type requestSuccess = (target: Target) => Action<Target>;
export type requestFailure = (error: Error) => Action;



export const request: request = (id: string): Action<ReadPayload> => {
  return {
      type: REQUEST,
      payload: {
        id: id,
      },
    };
};

export const requestSuccess: requestSuccess = (target: Target): Action<Target> => {
  return {
      type: REQUEST_SUCCESS,
      payload: target,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
