import Action from '@overflow/commons/redux/Action';
import Target from '../../api/model/Target';
import Probe from '@overflow/probe/api/model/Probe';
import ReadAllByProbePayload from '../payload/ReadAllByProbePayload';

// Action Type
export type REQUEST = '@overflow/target/read_all_by_probe/REQUEST';
export type REQUEST_SUCCESS = '@overflow/target/read_all_by_probe/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/target/read_all_by_probe/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/target/read_all_by_probe/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/target/read_all_by_probe/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/target/read_all_by_probe/REQUEST_FAILURE';

// Action Creater
export type request = (probe: Probe) => Action<ReadAllByProbePayload>;
export type requestSuccess = (targets: Target[]) => Action<Target[]>;
export type requestFailure = (error: Error) => Action;



export const request: request = (probe: Probe): Action<ReadAllByProbePayload> => {
  return {
      type: REQUEST,
      payload: {
        probe: probe,
      },
    };
};

export const requestSuccess: requestSuccess = (targets: Target[]): Action<Target[]> => {
  return {
      type: REQUEST_SUCCESS,
      payload: targets,
    };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
      type: REQUEST_FAILURE,
      error: error,
    };
};
