import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Target from '../../api/model/Target';
import TargetService from '../../api/service/TargetService';
import * as ReadActions from '../action/read';
import ReadPayload from '../payload/ReadPayload';

function* read(action: Action<ReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retTarget = yield call(AppContext.getService<TargetService>().read, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retTarget));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
