import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Target from '../../api/model/Target';
import TargetService from '../../api/service/TargetService';
import * as ReadAllByProbeActions from '../action/read_all_by_probe';
import ReadAllByProbePayload from '../payload/ReadAllByProbePayload';

function* readAllByProbe(action: Action<ReadAllByProbePayload>): SagaIterator {
  try {
    const {probe} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retTargets = yield call(AppContext.getService<TargetService>().readAllByProbe, probe);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadAllByProbeActions.requestSuccess(retTargets));
  } catch (e) {
    yield put(ReadAllByProbeActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchReadAllByProbe(): SagaIterator {
  yield takeLatest(ReadAllByProbeActions.REQUEST, readAllByProbe);
}
