import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Target from '../../api/model/Target';
import TargetService from '../../api/service/TargetService';
import * as RegistActions from '../action/regist';
import RegistPayload from '../payload/RegistPayload';

function* regist(action: Action<RegistPayload>): SagaIterator {
  try {
    const {target} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const retTarget = yield call(AppContext.getService<TargetService>().regist, target);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistActions.requestSuccess(retTarget));
  } catch (e) {
    yield put(RegistActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegist(): SagaIterator {
  yield takeLatest(RegistActions.REQUEST, regist);
}
