import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Target from '../../api/model/Target';
import TargetDiscoveryService from '../../api/service/TargetDiscoveryService';
import * as RegistDiscoveredTargetActions from '../action/regist_discovered_target';
import RegistDiscoveredTargetPayload from '../payload/RegistDiscoveredTargetPayload';

function* registDiscoveredTarget(action: Action<RegistDiscoveredTargetPayload>): SagaIterator {
  try {
    const {hosts, probe} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    yield call(AppContext.getService<TargetDiscoveryService>().saveAllTarget, hosts, probe);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RegistDiscoveredTargetActions.requestSuccess());
  } catch (e) {
    yield put(RegistDiscoveredTargetActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRegistDiscoveredTarget(): SagaIterator {
  yield takeLatest(RegistDiscoveredTargetActions.REQUEST, registDiscoveredTarget);
}
