import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';

import AppContext from '@overflow/commons/context';
import Action from '@overflow/commons/redux/Action';

import Target from '../../api/model/Target';
import TargetService from '../../api/service/TargetService';
import * as RemoveActions from '../action/remove';
import RemovePayload from '../payload/RemovePayload';

function* remove(action: Action<RemovePayload>): SagaIterator {
  try {
    const {target} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    yield call(AppContext.getService<TargetService>().remove, target);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(RemoveActions.requestSuccess());
  } catch (e) {
    yield put(RemoveActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchRemove(): SagaIterator {
  yield takeLatest(RemoveActions.REQUEST, remove);
}
